<template>
	<view class="main-container" v-if="showAll">
		<!-- <page-header v-if="showNav" :isIndex="true" :fixedHeight="fixedHeight" :naviBarHeight="naviBarHeight"></page-header> -->
		<page-header :isIndex="true" :fixedHeight="fixedHeight" :naviBarHeight="naviBarHeight"></page-header>
		<view class="main-lower-container">
			<view :class="isBigiPhone ? 'index-logo-big' : 'index-logo'"></view>
			<view class="handle-btn">
				<view v-if="showHandleBtnType === 0" class="handle-btn-area" @click="goHandle(0)">
					<button class="auth-btn" open-type="getUserInfo" @getuserinfo="handleGoBtn"></button>
				</view>
				<view v-if="showHandleBtnType === 1" class="handle-btn-area" @click="goHandle(1)"></view>
			</view>
		</view>
		<noti v-if="showNoti" :notiType="notiType" @close-noti="closeNoti"></noti>
	</view>
</template>

<script>
import PageHeader from './pageHeader.vue';
import Noti from './notification.vue';

export default {
	onLoad() {
		wx.getSystemInfo({
			success: res => {
				console.log('getSystemInfo at cook index === ', res);
				let menuRect = wx.getMenuButtonBoundingClientRect()
				console.log("menuRect === ", menuRect)
				getApp().globalData.statusBarHeight = res.statusBarHeight + 40;
				getApp().globalData.topStatusBar = res.statusBarHeight;
				getApp().globalData.titleBarHeight = (wx.getMenuButtonBoundingClientRect().top - res.statusBarHeight) * 2 + wx.getMenuButtonBoundingClientRect().height;
				getApp().globalData.fixedHeight = getApp().globalData.topStatusBar + getApp().globalData.titleBarHeight + 4;
				getApp().globalData.naviBarHeight = getApp().globalData.fixedHeight - getApp().globalData.topStatusBar;
				if (res.model.indexOf("iPhone") > -1 && res.windowHeight > 736) {
					getApp().globalData.isBigiPhone = true
				} else {
					getApp().globalData.isBigiPhone = false
				}
				this.fixedHeight = getApp().globalData.fixedHeight;
				this.naviBarHeight = getApp().globalData.naviBarHeight;
				// this.showNav = true;
				this.showAll = true;
			},
			fail: err => {
				// console.log(err)
			}
		});
	},
	data() {
		return {
			showAll: false,
			// showNav: false,
			fixedHeight: 0,
			naviBarHeight: 0,
			isBigiPhone: null,
			showHandleBtnType: -1, // 0 未授权 1 已授权
			goBtnClicked: false,
			isLoading: false,
			showNoti: false,
			notiType: 11, // 活动已经结束
			isOver: true
		};
	},
	mounted() {
		getApp().td_app_sdk.event({
			id: '/meatball/index',
			label: 'pv'
		});
		this.isBigiPhone = getApp().globalData.isBigiPhone;
		this.uniLogin();
		uni.getStorage({
			key: 'hasHandleAuth',
			success: res => {
				console.log('getStorage res at Cook Index === ', res);
				if (res.data === true) {
					this.showHandleBtnType = 1;
				} else {
					this.showHandleBtnType = 0;
				}
				getApp().globalData.hasHandleAuth = res.data;
			},
			fail: err => {
				console.log('getStorage err at Cook Index === ', err);
				this.showHandleBtnType = 0;
				getApp().globalData.hasHandleAuth = false;
			}
		});
		if (this.isOver) {
			this.showNoti = true;
		}
	},
	methods: {
		goHandle(type) {
			console.log('goHandle at cook index === ', type);
			getApp().td_app_sdk.event({
				id: 'meatball_index_立即参与',
				label: 'click'
			});
			if (type === 0) {
				getApp().globalData.hasHandleAuth = false;
			} else if (type === 1) {
				getApp().globalData.hasHandleAuth = true;
				uni.navigateTo({
					url: '/pages/meatball/list'
				});
			}
		},
		handleGoBtn(res) {
			this.goBtnClicked = true;
			this.uniLogin(res);
		},
		uniLogin() {
			console.log('------ Start uniLogin ------');
			uni.showLoading({
				title: '加载中',
				mask: true
			});
			uni.login({
				provider: 'weixin',
				success: loginRes => {
					console.log('uni login success === ', loginRes);
					getApp().globalData.userCookLoginCode = loginRes.code;
					console.log('userLoginCode === ', getApp().globalData.userCookLoginCode);
					uni.getUserInfo({
						provider: 'weixin',
						success: infoRes => {
							console.log('uni getUserInfo success');
							console.log('infoRes === ', infoRes);
							console.log('infoRes.userInfo === ', infoRes.userInfo);
							console.log('infoRes.encryptedData === ', infoRes.encryptedData);
							console.log('infoRes.iv === ', infoRes.iv);
							getApp().globalData.userInfoCook = infoRes.userInfo;
							this.bindGetUserInfo(infoRes);
						},
						fail: err => {
							console.log('uni getUserInfo failed === ', err);
							uni.hideLoading();
							if (Number(err.err_code) === -12006) {
								console.log('用户拒绝授权');
								getApp().globalData.hasHandleAuth = false;
								getApp().globalData.hasAlreadyAuthed = false;
								if (this.goBtnClicked) {
									uni.navigateTo({
										url: '/pages/meatball/list'
									});
								}
							} else if (err.errMsg.indexOf('scope unauthorized') > -1) {
								console.log('用户未授权');
								getApp().globalData.hasAlreadyAuthed = false;
							}
						}
					});
				},
				fail: err => {
					console.log('uni login failed === ', err);
					uni.hideLoading();
				}
			});
		},
		bindGetUserInfo(res) {
			console.log('getUserInfo at cook index res === ', res);
			let dataInfo;
			if (res.hasOwnProperty('detail')) {
				dataInfo = res.detail;
			} else {
				dataInfo = res;
			}
			uni.request({
				header: {
					'content-type': 'application/x-www-form-urlencoded' //自定义请求头信息
				},
				method: 'POST',
				url: getApp().globalData.baseUrlCook + 'code2session.php',
				data: {
					code: getApp().globalData.userCookLoginCode,
					encryptedData: dataInfo.encryptedData,
					iv: dataInfo.iv,
					avatar: dataInfo.userInfo.avatarUrl,
					nickname: dataInfo.userInfo.nickName,
					signature: dataInfo.signature
				},
				success: resWechat => {
					console.log('resWechat === ', resWechat);
					uni.hideLoading();
					if (resWechat.data.status === '1') {
						console.log('resWechat success === ', resWechat);
						uni.setStorage({
							key: 'hasHandleAuth',
							data: true,
							success: res => {
								getApp().globalData.hasHandleAuth = true;
							},
							fail: err => {
								console.log('err === ', err);
								getApp().globalData.hasHandleAuth = false;
							}
						});
						getApp().globalData.hasAlreadyAuthed = true;
						let data = resWechat.data.data;
						getApp().globalData.userUnionIdCook = data.uid;
						console.log('check userUnionIdCook at Cook Index === ', getApp().globalData.userUnionIdCook);
						this.showHandleBtnType = 1;
						if (this.goBtnClicked) {
							uni.navigateTo({
								url: '/pages/meatball/list'
							});
						}
					} else {
						// 调用失败
						getApp().globalData.hasAlreadyAuthed = false;
						uni.setStorage({
							key: 'hasHandleAuth',
							data: true,
							success: res => {
								getApp().globalData.hasHandleAuth = true;
							},
							fail: err => {
								console.log('err === ', err);
								getApp().globalData.hasHandleAuth = false;
							}
						});
					}
				},
				fail: err => {
					console.log('err === ', err);
					uni.hideLoading();
				}
			});
		},
		closeNoti(info) {
			console.log("closeNoti at meatball index === ", info);
			uni.navigateTo({
				url: '/pages/index/index'
			})
		},
		onShareAppMessage: res => {
			return {
				title: '票选人气肉丸 上榜宜家菜单',
				path: 'pages/meatball/index',
				imageUrl: 'https://ikea-mrm.woaap.com/images/meatball/share-back.jpg'
			};
		}
	},
	watch: {
		fixedHeight(n, o) {
			console.log("fixedHeight in watch 1 === ", n);
			console.log("fixedHeight in watch 2 === ", o);
		}
	},
	components: {
		PageHeader,
		Noti
	}
};
</script>

<style lang="scss" scoped>
.main-container {
	display: flex;
	justify-content: center;
	align-items: flex-start;
	flex-wrap: wrap;
	width: 100%;
	height: 100vh;
	position: relative;
}
.main-lower-container {
	width: 100%;
	height: 100vh;
	overflow-y: hidden;
	display: flex;
	flex-wrap: wrap;
	position: absolute;
	left: 0;
	top: 0;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-index-back.png');
	background-size: cover;
	background-repeat: no-repeat;
	background-position: center;
}
.index-logo {
	width: 114rpx;
	height: 46rpx;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-logo.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	position: absolute;
	// top: 131rpx;
	top: 168rpx;
	left: 35rpx;
}
.index-logo-big {
	width: 114rpx;
	height: 46rpx;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-logo.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	position: absolute;
	// top: 179rpx;
	top: 216rpx;
	left: 35rpx;
}
.handle-btn {
	// width: 715rpx;
	// height: 265rpx;
	width: 695rpx;
	height: 243rpx;
	position: absolute;
	// bottom: -12rpx;
	// bottom: -1rpx;
	bottom: 41rpx;
	// left: calc((100% - 716rpx) / 2);
	left: calc((100% - 695rpx) / 2);
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/btn-index-go.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	display: flex;
	justify-content: center;
	align-items: center;
}
.handle-btn-area {
	width: 560rpx;
	height: 102rpx;
}
/* auth */
.auth-btn {
	width: 100%;
	height: 100%;
	border: none !important;
	border-radius: 0 !important;
	background-color: transparent;
}
.auth-btn:after {
	border: none !important;
}
</style>
